/**********************************************************
						WARPOFDMTX.C
WARPOFDM is the driver that allows user code to manipulate
states of both the OFDM transmitter and receiver.
Additionally, it allows direct control of certain behaviour
of PHY.

Author: Chris Hunter 5/25/06
***********************************************************/

#include "xparameters.h"
#include "radio_controller.h"
#include "xparameters.h"
#include "ofdm_TxRx_mimo.h"

//********Transmitter********

void mimo_ofdmTx_init(){


	unsigned int modMasks_qpsk[24] = {0x02222220, 0x22222222, 0x22022222, 0x00000222, 0x22000000, 0x22220222, 0x22222222, 0x22222202, 0x02222220, 0x22222222, 0x22022222, 0x00000222, 0x22000000, 0x22220222, 0x22222222, 0x22222202, 0x02222220, 0x22222222, 0x22022222, 0x00000222, 0x22000000, 0x22220222, 0x22222222, 0x22222202};
	unsigned int modMasks_16qam[24] = {0x04444440, 0x44444444, 0x44044444, 0x00000444, 0x44000000, 0x44440444, 0x44444444, 0x44444404, 0x04444440, 0x44444444, 0x44044444, 0x00000444, 0x44000000, 0x44440444, 0x44444444, 0x44444404, 0x04444440, 0x44444444, 0x44044444, 0x00000444, 0x44000000, 0x44440444, 0x44444444, 0x44444404};
	unsigned int modMasks_64qam[24] = {0x08888880, 0x88888888, 0x88088888, 0x00000888, 0x88000000, 0x88880888, 0x88888888, 0x88888808, 0x08888880, 0x88888888, 0x88088888, 0x00000888, 0x88000000, 0x88880888, 0x88888888, 0x88888808, 0x08888880, 0x88888888, 0x88088888, 0x00000888, 0x88000000, 0x88880888, 0x88888888, 0x88888808};

	unsigned char i;


	/*
	for(i=0; i<24; i++)
	{
		*((volatile unsigned int*)(XPAR_OFDM_TXRX_MIMO_OPBW_0_BASEADDR+ofdm_TxRx_mimo_SMWO_RxModulation_OFFSET+i*sizeof(int))) =
			modMasks_qpsk[i];
	}

	for(i=0; i<24; i++)
	{
		*((volatile unsigned int*)(XPAR_OFDM_TXRX_MIMO_OPBW_0_BASEADDR+ofdm_TxRx_mimo_SMWO_TxModulation_OFFSET+i*sizeof(int))) =
			modMasks_qpsk[i];
	}
	*/

	*((volatile unsigned int*)(XPAR_OFDM_TXRX_MIMO_OPBW_0_BASEADDR+ofdm_TxRx_mimo_Tx_Start_Reset_Control_OFFSET)) = 0x1|0x4;//Raise master reset


}

void mimo_ofdmTx_setControlBits(unsigned int txOptions) {
	*((volatile unsigned int*)(XPAR_OFDM_TXRX_MIMO_OPBW_0_BASEADDR+ofdm_TxRx_mimo_Tx_ControlBits_OFFSET)) = txOptions;
	return;
}

void mimo_ofdmTx_enable(){
	/*
		-Lowers master reset
	*/

	*((volatile unsigned int*)(XPAR_OFDM_TXRX_MIMO_OPBW_0_BASEADDR+ofdm_TxRx_mimo_Tx_Start_Reset_Control_OFFSET)) = 0;		   	//Raise master reset
	*((volatile unsigned int*)(XPAR_OFDM_TXRX_MIMO_OPBW_0_BASEADDR+ofdm_TxRx_mimo_Tx_Start_Reset_Control_OFFSET)) = 2;	//Begin Transmit (posedge)
	*((volatile unsigned int*)(XPAR_OFDM_TXRX_MIMO_OPBW_0_BASEADDR+ofdm_TxRx_mimo_Tx_Start_Reset_Control_OFFSET)) = 0;
}


//********MAC-PHY Interface Commands********


void mimo_mac2phy_pktTx(unsigned int block, unsigned int radio){
	/*
		-Starts transmission of packet
		-Blocks and waits for completion if TXBLOCK
		-Exits immediately if TXNOBLOCK - WARNING: Burden is on user to toggle PacketDoneReset if this feature is used!
	*/
if(*((volatile unsigned int*)(XPAR_OFDM_TXRX_MIMO_OPBW_0_BASEADDR+ofdm_TxRx_mimo_Tx_PktDone_OFFSET)) == 1)
{





	//xil_printf("Enabling Tx: radio=%x\r\n",radio);
	WarpRadio_TxEnable(XPAR_RADIO_CONTROLLER_0_BASEADDR, radio);
//	usleep(500);

	if(block == TXBLOCK)
	{
		while(*((volatile unsigned int*)(XPAR_OFDM_TXRX_MIMO_OPBW_0_BASEADDR+ofdm_TxRx_mimo_Tx_PktDone_OFFSET)) == 0)
		{}
		//*((volatile unsigned int*)PacketDoneReset_address) = 1;
		//*((volatile unsigned int*)PacketDoneReset_address) = 0;
		WarpRadio_TxDisable(XPAR_RADIO_CONTROLLER_0_BASEADDR, radio);
	}
}
//else xil_printf("ERR: Illegal PHY use\r\n");
return;
}







